%module AGILe

%{
  #define SWIG_FILE_WITH_INIT
  #include "AGILe/Loader.hh"
  #include "AGILe/Generator.hh"
  #include "AGILe/Run.hh"
  #include "AGILe/Tools/Logging.hh"
%}

// HepMC
//%include "hepmc.i"

// STL templates
%include "std_string.i"
%include "std_vector.i"
%include "std_map.i"
%template(StrList) std::vector<std::string>;
%template(LogLevelMap) std::map<std::string, int>;


namespace AGILe {
  %rename(setLogLevel) Log::setLevel(const std::string&, int);
}
%include "AGILe/Tools/Logging.hh"

%include "AGILe/Particle.hh"

namespace AGILe {
  %ignore Generator::getState;
  %ignore Generator::setState;
}
%include "AGILe/Generator.hh"

namespace AGILe {
  //  %ignore Run::Run(const Run&);
  %ignore Run::Run(Generator&);
  %ignore Run::event;
}
%include "AGILe/Run.hh"

%include "AGILe/Loader.hh"
